// system.h
// Gregory Rosenblatt

#ifndef System_H_
#define System_H_

#include <iostream>
#include <vector>
#include <string>

namespace Test
{
    class System
    {
    public:
        enum { num_commands = 2 };
        // vm interface
        int DrawStars(const std::vector<int>& argv)
            { if (argv.size() < 2) return -1; OutputStars(argv[0], argv[1]); return 0; }
        int CalcFactorial(const std::vector<int>& argv)
            { if (argv.size() < 1) return -1; return Factorial(argv[0]); }
    private:
        void OutputStars(size_t numStars, size_t padding)
        {
            std::string padString;
            size_t i;
            for (i = 0; i < padding; ++i)
                padString += ' ';
            for (i = 0; i < numStars; ++i)
                std::cout << '*' << padString;
            std::cout << std::endl;
        }
        int Factorial(size_t input)
        {
            // initialize
            int counter = input;
            int result = 1;
            // iterative loop
            while (counter > 1)
            {
                result *= counter;
                --counter;
            }
            // output
            return result;
        }
    };
}

#endif

